Index: main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 17430)
+++ main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 17431)
@@ -1,4 +1,4 @@
-# -*- coding: utf-8 -*-
-## $Id$
+    # -*- coding: utf-8 -*-
+## $Id: browser.py 17429 2023-06-05 04:34:30Z henrik $
 ##
 ## Copyright (C) 2012 Uli Fouquet & Henrik Bettermann
@@ -9,5 +9,5 @@
 ##
 ## This program is distributed in the hope that it will be useful,
-## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## but WITHOUT ANY WARRANTY; without even the implied warranty ofself.context.amount_auth
 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ## GNU General Public License for more details.
@@ -20,4 +20,6 @@
 import hashlib
 import grok
+import os
+import csv
 from xml.dom import minidom
 from zope.interface import Interface
@@ -30,4 +32,5 @@
     InterswitchPaymentVerifyWebservicePageStudent,
     InterswitchPageStudent, InterswitchPageApplicant,
+    module_activated,
     )
 from waeup.aaue.students.interfaces import ICustomStudentOnlinePayment
@@ -35,6 +38,5 @@
 from waeup.aaue.interfaces import MessageFactory as _
 
-PRODUCT_ID_PT = '5040'
-PRODUCT_ID_REGULAR = '5845'
+PRODUCT_ID = '5845'
 SITE_NAME = 'aaue.waeup.org'
 PROVIDER_ACCT = '0200244434'
@@ -49,39 +51,32 @@
 URL = '/paydirect/api/v1/gettransaction.json'
 HTTPS = True
-MAC_REGULAR = '9718FA00B0F5070B388A9896ADCED9B2FB02D30F71E12E68BDADC63F6852A3496FF97D8A0F9DA9F753B911A49BB09BB87B55FD02046BD325C74C46C0123CF023'
-MAC_PT = '74424F1DFECD6058F153148255CDD55E16724B4F380ADB2C63C5D1D7A5675759010C8153DCB930AAF2D38903CBF7CE32B8A6BA2C16BBC46721DF2E3F3E4548E3'
+MAC = '9718FA00B0F5070B388A9896ADCED9B2FB02D30F71E12E68BDADC63F6852A3496FF97D8A0F9DA9F753B911A49BB09BB87B55FD02046BD325C74C46C0123CF023'
 
 httplib.HTTPSConnection.debuglevel = 0
 
-
-def gateway_net_amt(fee):
-    if fee > GATEWAY_AMT:
-        return fee - GATEWAY_AMT
-    return 0.0
-
-def contr_agreement_applicant(applicant):
-    if applicant.__parent__.prefix in (
-        'fp',
-        'ptee',
-        'dsh',
-        'bridge',
-        'ijmbe',
-        ):
-        return 'first'
-    return 'second'
-
-def contr_agreement_student(student):
-    if student.current_mode in (
-        'found',
-        'bridge',
-        'ug_dsh',
-        'de_dsh',
-        'ug_pt',
-        'de_pt',
-        'dp_pt',
-        'ijmbe',
-        ):
-        return 'first'
-    return 'second'
+BANK_ACCOUNTS = {
+    'edohis':   ('1222577132', '117', 'Edo State Health Insurance'),
+    'union':    ('1019763348', '7', 'Student Union'),
+    'sport':    ('1021941220', '7', 'Sport Development'),
+    'access':   ('1012688013', '123', 'Access Card'),
+    'notebook': ('4011210501', '51', 'Branded Notebook'),
+    'library':  ('2000122995', '8', 'Library Development'),
+    'fac1':     ('1022438743', '7', 'Faculty Fee'),
+    'fac2':     ('2000249757', '8', 'Faculty Fee'),
+    'fac3':     ('1012678566', '123', 'Faculty Fee'),
+    'acceptance': ('2000249757', '8', 'Acceptance Fee'),
+    'matricgown': ('2000249757', '8', 'Matriculation Gown Fee'),
+    'lapel':      ('2000249757', '8', 'Lapel Fee'),
+    }
+
+schoolfees_path = os.path.join(
+    os.path.dirname(__file__), '../students/schoolfees.csv')
+reader = csv.DictReader(open(schoolfees_path, 'rb'))
+SCHOOLFEES = {item['code']:item for item in reader}
+
+acceptancefees_path = os.path.join(
+    os.path.dirname(__file__), '../students/acceptancefees.csv')
+reader = csv.DictReader(open(acceptancefees_path, 'rb'))
+ACCEPTANCEFEES = {item['code']:item for item in reader}
 
 class CustomInterswitchPageApplicant(InterswitchPageApplicant):
@@ -97,9 +92,12 @@
     provider_bank_id = PROVIDER_BANK_ID
     provider_acct = PROVIDER_ACCT
-    institution_acct = '1010835352'
-    institution_bank_id = '117'
+    pay_item_id = '101'
 
     def update(self):
-
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
+            self.flash(_('Forbidden'), type='danger')
+            self.redirect(self.url(self.context, '@@index'))
+            return
         error = self.init_update()
         if error:
@@ -107,64 +105,28 @@
             self.redirect(self.url(self.context, '@@index'))
             return
-        self.context.r_company = u'interswitch'
+        # Already now it becomes an Interswitch payment. We set the net amount
+        # and add the gateway amount.
+        if not self.context.r_company:
+            self.context.net_amt = self.context.amount_auth
+            self.context.amount_auth += GATEWAY_AMT
+            self.context.gateway_amt = GATEWAY_AMT
+            self.context.r_company = u'interswitch'
+        xmldict = {}
         provider_amt = 2000.0
-        fedex_amt = 0.0
-        if contr_agreement_applicant(self.applicant) == 'first':
-            self.product_id = PRODUCT_ID_PT
-            self.pay_item_id = '101'
-            self.mac = MAC_PT
-            if self.applicant.__parent__.prefix == 'ijmbe':
-                self.institution_bank_id = '123'
-                self.institution_acct = '1012278272'
-        else:
-            self.product_id = PRODUCT_ID_REGULAR
-            self.pay_item_id = '109'
-            self.mac = MAC_REGULAR
-            if self.applicant.__parent__.prefix in ('utme', 'ude'):
-                provider_amt = 1000.0
-            elif self.applicant.__parent__.prefix in ('trans', 'cert'):
-                self.institution_acct = '1010827641'
-                self.institution_bank_id = '117'
-                self.provider_bank_id = '10'
-                self.provider_acct = '0427773399'
-                if self.applicant.applicant_id[:5] in ('cert7', 'cert8'):
-                    provider_amt = 0.0
-                if self.applicant.applicant_id[:6] in ('trans5', 'trans6'):
-                    self.institution_acct = '5210006575'
-                    self.institution_bank_id = '51'
-                #if self.applicant.applicant_id[:6] in ('trans1', 'trans6'):
-                #    fedex_amt = 10500.0
-                if self.context.p_category == 'app_balance':
-                    provider_amt = 0.0
-            elif self.applicant.applicant_id.startswith('bridge'): # easier to test
-                self.institution_acct = '1014847058'
-                self.institution_bank_id = '7'
-            elif self.applicant.applicant_id.startswith('dsh'): # easier to test
-                self.institution_acct = '1014847058'
-                self.institution_bank_id = '7'
-            elif self.applicant.__parent__.prefix in ('ver', 'send'):
-                provider_amt = 0.0
-            elif self.applicant.__parent__.prefix == 'fedex':
-                provider_amt = 0.0
-                self.institution_acct = '0001115694'
-                self.institution_bank_id = '10'
-            elif self.applicant.applicant_id.startswith('pg'):
-                self.institution_acct = '5210006575'
-                self.institution_bank_id = '51'
-
-        xmldict = {}
+        if self.applicant.applicant_id.startswith('trans'):
+            provider_amt = 3000.0
+        xmldict['institution_acct'] = '00000000'
+        xmldict['institution_bank_id'] = '00'
         xmldict['detail_ref'] = self.context.p_id
         xmldict['provider_amt'] = 100 * provider_amt
-        xmldict['provider_acct'] = self.provider_acct
-        xmldict['provider_bank_id'] = self.provider_bank_id
+        xmldict['provider_acct'] = PROVIDER_ACCT
+        xmldict['provider_bank_id'] = PROVIDER_BANK_ID
         xmldict['provider_item_name'] = PROVIDER_ITEM_NAME
-        xmldict['institution_acct'] = self.institution_acct
-        xmldict['institution_bank_id'] = self.institution_bank_id
-        xmldict['institution_item_name'] = self.category
+        xmldict['institution_item_name'] = self.context.category
         xmldict['institution_name'] = INSTITUTION_NAME
-        xmldict['fedex_amt'] = 100 * fedex_amt
-        xmldict['institution_amt'] = 100 * (
-            self.context.amount_auth - provider_amt - fedex_amt - GATEWAY_AMT)
-
+        xmldict['institution_amt'] = 100 * self.context.net_amt
+        if not self.context.provider_amt:
+            self.context.provider_amt = provider_amt
+            self.context.amount_auth += provider_amt
         xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s">
@@ -173,37 +135,5 @@
 </item_details>
 </payment_item_detail>""" % xmldict
-
-        if provider_amt == 0.0:
-            xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
-        if fedex_amt:
-            xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-<item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
-<item_detail item_id="3" item_name="FedEx" item_amt="%(fedex_amt)d" bank_id="10" acct_num="0001115694" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
-        if self.applicant.applicant_id.startswith('pg'):
-            handbook_amount = 2000.0
-            xmldict['handbook_amount'] = 100 * handbook_amount
-            xmldict['institution_amt'] = 100 * (
-                self.context.amount_auth - provider_amt - handbook_amount -GATEWAY_AMT)
-            xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-<item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
-<item_detail item_id="3" item_name="PG Handbook" item_amt="%(handbook_amount)d" bank_id="51" acct_num="5210006575" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
         self.xml_data = """<input type="hidden" name="xml_data" value='%s'  />""" % xmltext
-        self.context.provider_amt = provider_amt
-        self.context.gateway_amt = GATEWAY_AMT
         xmlitems = ''
         xmldoc = minidom.parseString(xmltext)
@@ -221,11 +151,10 @@
         hashargs = (
             self.context.p_id +
-            self.product_id +
+            PRODUCT_ID +
             self.pay_item_id +
             str(int(self.amount_auth)) +
             self.site_redirect_url +
-            self.mac)
+            MAC)
         self.hashvalue = hashlib.sha512(hashargs).hexdigest()
-
         return
 
@@ -238,7 +167,12 @@
     site_name = SITE_NAME
     currency = CURRENCY
-    pay_item_id = '000'
+    pay_item_id = '101'
 
     def update(self):
+        if not module_activated(
+            self.context.student.current_session, self.context):
+            self.flash(_('Forbidden'), type='danger')
+            self.redirect(self.url(self.context, '@@index'))
+            return
         error = self.init_update()
         if error:
